#include   <errno.h>
#include   <sys/types.h>
#include   <stdio.h>
#include   <sys/socket.h>
#include   <netinet/in.h>
#include   <netdb.h> 
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "define.h"

unsigned short int verbose;

void verbosity(char *s)
{
    if (verbose == 1) {
	printf ("%s",s);
	fflush(NULL);
    }
}

int read_from_socket(int sock, char *message) 
{
  int retval,i;
  char msg[3];
  int koniec;


  koniec = 0;


  verbosity("*** Reading from socket...");

  i = 0; msg[0] = 1; msg[1] = 1;
  while(!(msg[0]=='\n' || (msg[0]=='\0') || (i>=MAX_MSG_LENGTH) )) {
    retval = recv (sock, msg, 1, 0);
    if (retval == -1) {
      perror ("receive");
      return (-1);
    }
    if(msg[0]>=32) message[i] = msg[0]; 
    else 
      if(!(msg[0]==26 || (msg[0]==13))) i--;
    i++;
  }
  message[i-1] = '\0';
  if(msg[0]==26) return (1);

  /* printf("docital som z socketu\n"); */

  verbosity("done.\n");

  return (0);
}



int write_in_socket(int sock, char *odpoved)
{
  int retval;

  verbosity("*** Writing to socket...");

  retval = send (sock, odpoved, strlen (odpoved), 0);
    if (retval == -1) {
      perror ("send");
      return (-1);
    } 
    
  verbosity("done.\n");


  return (0);
}




void cleanup (int how_many, int sock1, int sock2)
{
	int retval;

	verbosity("*** Closing socket...");


	/*
	** Shutdown and close sock1 completely.
	*/
	retval = shutdown (sock1,2);
	if (retval == -1)
	  perror ("shutdown");

	retval = close (sock1);
	if (retval)
	  perror ("close");

	/*
	** If given, shutdown and close sock2.
	*/

	if (how_many == 2) {
	  retval = shutdown (sock2,2);
	  if (retval == -1)
	    perror ("shutdown");

	  retval = close (sock2);
	  if (retval)
	    perror ("close");
	}
	
	if (verbose > 0) 
	verbosity("done.\n");
	


} 


int readmessage(char *message)
{
  verbosity("*** Waiting for you:\n");

  if (fgets(message, MAX_MSG_LENGTH, stdin) == NULL) return(-2);
  if (strlen(message) == 1) return(-1);
  return (0);
}



int main (int argc, char **argv)
{
        int sock_2;                   /* socket */
	static struct sockaddr_in sock2_name;    /* Address str. for socket2 */
        struct hostent hostentstruct;           /* Storage for hostent data. */
        struct hostent *hostentptr;             /* Pointer to hostent data.  */
	char  *p;
        int retval;                            /* helpful for debugging */
        
  char fromluser[MAX_LUSERNAME_LENGTH], toluser[MAX_LUSERNAME_LENGTH]="", totty[MAX_TTY_LENGTH]="";
  char buffer[MAX_SOCK_LENGTH];
  char inbuffer[MAX_MSG_LENGTH];
  unsigned int toport=XTELL_DEFAULT_PORT;
  char bufftoluser[MAX_LUSERNAME_LENGTH+MAX_TTY_LENGTH+2]="";
  char buffhost[MAX_HOSTNAME+10]="", tohost[MAX_HOSTNAME]="";

  unsigned int i;
  
        if(argc == 1) {      /* nespravny pocet parametrov */

          printf("Usage: xtell [-v] name[:tty][@address[%%port]] [message]\n");
          exit(1);

        }
	
	verbose = 0;
	i = 1;

	if (!strcmp(argv[i], "-v")) {
	    verbose = 1;
	    printf("*** Verbose mode is on\n");
	    i++;
            if(argc == 2) {      /* nespravny pocet parametrov */
               printf("Usage: xtell [-v] name[:tty][@address[%%port]] [message]\n");
               exit(1);
	    }
	}

        if((p = strchr(argv[i],'@')) == NULL) {
        	strncat(bufftoluser,argv[i],sizeof(bufftoluser));
		if (gethostname(buffhost,MAX_HOSTNAME) < 0) {
			perror("Error in getting hostname");
			exit(1);	
		}		  
	} else {
		strncat(bufftoluser,argv[i],p-argv[i]);
		strncat(buffhost,p+1,strlen(argv[i])-(p-argv[i]));
	}
	
	if((p = strchr(bufftoluser,':')) != NULL) {
		strncat(toluser,bufftoluser,p-bufftoluser);
		strncat(totty,p+1,MAX_TTY_LENGTH);
	} else {
		strncpy(toluser,bufftoluser,sizeof(toluser));
	}
	
	if((p = strchr(buffhost,'%')) != NULL) {
		strncat(tohost,buffhost,p-buffhost);
		toport=atoi(p+1);
	} else {
		strncpy(tohost,buffhost,sizeof(tohost));
	}
	
//	printf("user %s, tty %s, host %s, port %i",toluser,totty,tohost,toport);		
	

/*    
	if ((sock_2 = socket (AF_INET, SOCK_STREAM, 0)) == -1) {
	  perror( "socket");
	  exit(1);
	}
*/
/*	retval = gethostname (myaddr, sizeof(myaddr));
	if (retval) {
	  perror ("gethostname");
	  cleanup (1, sock_2, 0); 
          exit(1);
	} 
*/
        cuserid(fromluser);
	
	verbosity("*** Getting host address...");
	    
	if ((hostentptr = gethostbyname (tohost)) == NULL) {
	printf("%s\n",tohost);
          perror("Host not found");
          return(-1);
	}
	
	verbosity("done.\n");
	
/*
	printf ("Address: %u.%u.%u.%u\n", 
	  (unsigned char) (*hostentptr->h_addr_list)[0],
	  (unsigned char) (*hostentptr->h_addr_list)[1],
	  (unsigned char) (*hostentptr->h_addr_list)[2],
	  (unsigned char) (*hostentptr->h_addr_list)[3]);
*/
	hostentstruct = *hostentptr;

	sock2_name.sin_family = hostentstruct.h_addrtype;
	sock2_name.sin_port = htons(toport);
	sock2_name.sin_addr = * ((struct in_addr *) hostentstruct.h_addr);

        /* printf("kam sa vlastne napajame ?? predsa: %s\n",hostentstruct.h_name);*/


        if ((sock_2 = socket (AF_INET, SOCK_STREAM, 0)) == -1) {
        	perror( "socket");
        	return(-1);
	}
						    
	verbosity("*** Connecting...");

        retval=connect(sock_2, &sock2_name, sizeof(sock2_name));
        if(retval) {
          perror ("connect");
          cleanup(1, sock_2, 0);
          return(-1);
        }

						    
	verbosity("done.\n");


	if (argc > i+1) {
		for (i++; i< argc; i++) {
#ifdef DONT_HAVE_SNPRINTF
			sprintf(buffer, "%s:%s:%s:%s\r\n", fromluser, toluser, totty, argv[i]);
#else
			snprintf(buffer,sizeof(buffer),"%s:%s:%s:%s\r\n", fromluser, toluser, totty, argv[i]);
#endif
			write_in_socket(sock_2, buffer);
			read_from_socket(sock_2, buffer);
			if(buffer[0] == '4') 
				printf("%s\n", buffer);
		}

	} else {

		while (readmessage(inbuffer) == 0) {
#ifdef DONT_HAVE_SNPRINTF
			sprintf(buffer, "%s:%s:%s:%s\r\n", fromluser, toluser, totty, inbuffer);
#else
			snprintf(buffer,sizeof(buffer),"%s:%s:%s:%s\r\n", fromluser, toluser, totty, inbuffer);
#endif
			write_in_socket(sock_2, buffer);
			read_from_socket(sock_2, buffer);
			if(buffer[0] == '4') 
				printf("%s\n", buffer);
		}
	        printf("Thank you for using xtell.\n");
	}
	
	sprintf(buffer,"QUIT\n");

	verbosity("*** Telling the other side we are through: ");

	write_in_socket(sock_2, buffer);
	
        cleanup(1, sock_2, 0);
	return(0);

} /* end main */

